Bug 1409931 - %gobuild incorrectly assumes all compiler flags are compatible with getopt
Summary: %gobuild incorrectly assumes all compiler flags are compatible with getopt
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: go-compilers
Version: 25
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Jan Chaloupka
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-01-03 22:47 UTC by Nalin Dahyabhai
Modified: 2017-12-12 10:16 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-12-12 10:16:57 UTC
Type: Bug


Attachments (Terms of Use)

Description Nalin Dahyabhai 2017-01-03 22:47:01 UTC
Description of problem:
The current definition of %gobuild:

  %gobuild(o:) go build -compiler gc -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n')" -a -v -x %{?**};

produces an (apparently harmless) error message if I try to pass flags that aren't a single character to the macro.  (In my case, "-tags".)  The set of arguments that the "go" command accepts includes some which are multiple characters long, so if %gobuild is meant to accept them, it needs to be corrected.

Version-Release number of selected component (if applicable):
go-compilers-golang-compiler-1-8.fc25.x86_64

How reproducible:
Always

Steps to Reproduce:
1. Modify a .spec file to pass build tags ("-tags 'foo bar'") to %gobuild

Actual results:
gobuild: invalid option -- 't'
error: Unknown option t in gobuild()
(build continues)

Expected results:
No error message, build continues.

Additional info:
This definition seems to accept arbitrary flags and produces the results I expect:

  %define gobuild() go build -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n')" -a -v -x %{**};

Comment 1 Jan Chaloupka 2017-01-04 14:57:56 UTC
The proposed solution works only if it is defined in the spec file itself.
The default %gobuild definition is defined under /usr/lib/rpm/macros.d/macros.golang-compiler file.

$ rpm -qf /usr/lib/rpm/macros.d/macros.golang-compiler
go-compilers-golang-compiler-1-7.fc24.x86_64

The original definition of the gobuild was via %define statement. However, that does not work in macros.d files.

The assumption for the %gobuild and %gotest macros is that they are used only with -o option. For other options, you should use the go build command directly or ignore the error message.

I agree ignoring the error message is not the best solution. However, I have not found any better solution so far. The rpm macros documentation does not tell much about macros.d files and supported syntax.

Comment 2 Nalin Dahyabhai 2017-01-06 20:21:04 UTC
Darn, I didn't realize that wouldn't also work in the macro configuration.

Comment 3 Reto Gantenbein 2017-11-02 06:25:42 UTC
Unfortunately the error cannot be ignored anymore on Fedora 27. Seeing the same issue when using %{gobuild} with -tags:

gobuild: invalid option -- 't'
error: Unknown option t in gobuild(o:)
error: line 243: %gobuild -o bin/lxd -tags=libsqlite3 %{import_path}/lxd

Comment 4 Fedora End Of Life 2017-11-16 19:01:15 UTC
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 5 Fedora End Of Life 2017-12-12 10:16:57 UTC
Fedora 25 changed to end-of-life (EOL) status on 2017-12-12. Fedora 25 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.